import Component from '@glimmer/component';

export default class plotXAxis extends Component {
  get axisY() {
    return this.args.height - this.axisStrokeWidth/2;
  }

  get axisStrokeWidth() {
    return this.args.strokeWidth
      ? this.args.strokeWidth
      : '1'
  }

  get axisStroke() {
    return this.args.stroke
      ? this.args.stroke
      : 'gray'
  }

  // Ticks only show with param @hasTicks

  get tickWidth() {
    return this.args.tickWidth || "1"
  }

  get tickHeight() {
    return this.args.tickHeight || this.axisStrokeWidth * 6
  }

  get tickCount() {
    return this.args.tickCount || 10
  }

  get tickStrokeWidth() {
    return this.args.tickStrokeWidth || this.axisStrokeWidth
  }

  get tickStroke() {
    return this.args.tickStroke || this.axisStroke
  }

  get ticks() {
    const ticks = [];
    const axisYBottom = this.axisY - this.tickHeight/2;
    const axisYTop = axisYBottom + this.tickHeight;
    const tickSpacing = this.args.width / (this.tickCount + 1)
    for(let i = 1; i <= this.tickCount; i++) {
      ticks.push({
        x: tickSpacing * i,
        y1: axisYBottom,
        y2: axisYTop,
        stroke: this.tickStroke,
        strokeWidth: this.tickWidth
      })
    }

    return  ticks;
  }
}